Strict

Framework brl.blitz
Import brl.max2d
Import brl.glmax2d
Import brl.Graphics
Import brl.random
Import brl.timer
Import brl.pngloader

SeedRnd MilliSecs()

Const GW = 800, GH = 600
Const MAXPOWER = 480
Global timer:TTimer = CreateTimer(50), clock
Global bgimg:TImage = LoadImage("bg.png"), score
Global power = MAXPOWER, quakescr = 0

AppTitle = "CRAZY ASDF UNIVERSE - BCC #67 - Thunder"
Graphics GW, GH
SetBlend ALPHABLEND

AutoMidHandle True
TBall.init
TBall.Create 4

Repeat
	SetColor 255, 255, 255
	SetRotation clock	
	If quakescr Then
		TileImage bgimg, Cos(clock)*20+(clock Mod 3)*6-3, Sin(clock)*20+(clock Mod 3)*6-3
		quakescr :- 5
	Else
		TileImage bgimg, Cos(clock)*20, Sin(clock)*20
	EndIf
	SetRotation 0
		
	SetColor 0,0,0
	SetScale 1.5, 1.5
	DrawText "SCORE: "+ score, 10, 10
	DrawText "POWER", GW-40-TextWidth("POWER"), 18
	SetScale 1,1
	DrawRect GW-MAXPOWER-22, 8, MAXPOWER+4, 10
	If power>=TBall.smackpower Then SetColor 255,255,0 Else SetColor 255,0,0
	DrawRect GW-MAXPOWER-20, 10, power, 6
	
	If power < MAXPOWER And (clock Mod 6) = 0 Then power :+ 5
	TBall.updateall
	TParticle.updateall
	TText.updateall

	If TBall.nouse Then
		TBall.nouse :- 1
		SetAlpha 0.4
		SetColor 0,0,0
		DrawRect 0,0,GW,GH
		SetAlpha 1
		SetColor 105,0,0
		SetScale 2.5, 2.5
		DrawText "KEYS BLOCKED", 100, 80
		DrawText "YOU SHALL NOT CHEAT!", 100, 120
		SetScale 1, 1
		If clock Mod 25 = 0 Then TBall.tilt
	EndIf

	clock :+ 1
	
	If clock Mod 4000 = 0 And TBall.list.length<8 Then
		TBall.Create
		TBall.SMACKPOWER :- 20
		TBall.gspeed :- 0.2
		TText.Create6 "NEXT BALL", GW/2, GH/2-100, 0, 0, 0
	EndIf
	
	Flip 0
	WaitTimer timer
Until KeyHit(KEY_ESCAPE) Or AppTerminate()
End

Type TBall
	Global SMACKPOWER = 100
	Global img:TImage
	Global list:TBall[]
	Global down = -1, lkeys[], ktimes[], nouse
	Global last:TBall[], combo, comboplus
	Global gspeed:Float = 1.5, speed:Float = gspeed, speed_r:Float = 0.97
	Field x:Float, y:Float, vx:Float, vy:Float
	Field w, key, dead

	Function init()
		img = LoadAnimImage("bs.png", 36, 36, 0, 6)
	EndFunction
	
	Function checkasdf()
		If lkeys.length <> 4 Then Return False	
		For Local i:Int = 0 To 3
			If i <> lkeys[i] Then Return False
		Next
		Return True
	EndFunction

	Function tilt()
		For Local b:TBall = EachIn list
			TText.Create6 "TILT", b.x, b.y, 100, 0, 0
		Next		
	EndFunction

	Function punish(l)
		quakescr = l
		last = Null
		lkeys = Null
		ktimes = Null		
	EndFunction

	Function checkkeys()	
		down = -1
		If Not nouse Then
			If KeyHit(KEY_A) Then down = 0
			If KeyHit(KEY_S) Then down = 1
			If KeyHit(KEY_D) Then down = 2
			If KeyHit(KEY_F) Then down = 3
		EndIf
		If down <> -1 Then ktimes:+[MilliSecs()];space()
		If lkeys.length>4 Then lkeys = lkeys[1..]
		If ktimes.length>4 Then ktimes = ktimes[1..]
		If ktimes.length = 4 And ktimes[3]-300 < ktimes[0] Then
			punish 100
			tilt
			TText.Create6 "-500", GW/2, GH/2, 100, 0, 0
			score :- 500
			nouse = 280
		EndIf
		If checkasdf() Then
			TText.Create6 "+4000 ASDF", GW/2, GH/2, 255, 255, 255
			score :+ 4000
			lkeys = Null
		EndIf
	EndFunction

	Function Create(n = 1)
		While n
			list:+[New TBall]
			n:-1
		Wend
	EndFunction
	
	Function space()
		Local l:TBall[], newlast:TBall[]
		Local np, pp, c, b:TBall
		comboplus = 0
		For b = EachIn list
			If b.key = down And b.findnear() Then
				np = b.smack(b.findnear(), newlast)
				If np Then
					pp :+ np
					TText.Create6 "+"+np, b.x, b.y, 0, 0, 115
					c:+1
				EndIf
			EndIf
		Next
		If c Then
			lkeys :+ [down]
			last = newlast
			combo :+ comboplus
			If quakescr = 0 Then
				If comboplus Then
					score:+pp*c*(combo+1)	
					TText.Create6 "+"+(pp*c*(combo+1)-pp)+" COMBO", GW/2, GH/2, 0, 125, 0
				Else
					score:+pp				
				EndIf
			EndIf
			If comboplus = 0 Then combo = 0
		EndIf
	EndFunction	
	
	Function updateall()
		checkkeys
		For Local b:TBall = EachIn list
			b.update
		Next
		If speed > gspeed+0.02 Then
			speed:*speed_r
		ElseIf speed < gspeed-0.02 Then
			speed:/speed_r
		ElseIf speed > gspeed Then
			speed :- 0.02
		ElseIf speed < gspeed Then
			speed :+ 0.02
		EndIf
	EndFunction		

	Method islast()
		If Not last Then Return False
		For Local b:TBall = EachIn last
			If b = Self Then Return True
		Next
		Return False
	EndMethod	

	Method smack(l:TBall[], newlast:TBall[] Var)
		Local neww:Float, b:TBall
		If power < SMACKPOWER Then Return
		power:-SMACKPOWER
		For b = EachIn l
			If b.islast() Then comboplus:+1
			neww :+ ATan2(y-b.y, x-b.x)
		Next
		newlast:+[Self]
		neww:/Float l.length
		w = neww
		vx = Cos(w)*6
		vy = Sin(w)*6
		TParticle.CreateN Self, 70
		Return (l.length*10)^2
	EndMethod
		
	Method New()
		Local b:TBall
		dead = 300
		Repeat
			x = Rand(0, GW)
			y = Rand(0, GH)
		Until findnear() = Null
		w = Rand(0, 359)
		key = list.length Mod 4
	EndMethod

	Method findnear:TBall[]()
		Local v, w, n:TBall[]
		For Local b:TBall = EachIn list
			v = b.x - Self.x
			w = b.y - Self.y
			If b <> Self And (v*v + w*w < 14400) Then n:+[b]
		Next
		Return n
	EndMethod

	Method update()
		Local i, j, near:TBall[]
		
		SetColor 255, 255, 255

		If dead Then
			SetAlpha 0.6+0.3*Sin(16*clock)
			DrawImage img, x, y, key
			SetScale 2, 2
			SetRotation clock*2
			DrawImage img, x, y, 4
			dead :- 4
			SetRotation 0
			SetScale 1, 1
			SetAlpha 1
			Return
		EndIf
		
		x:+Cos(w)*speed
		y:+Sin(w)*speed
		
		If vx<>0 Then
			x:+vx*speed
			vx:*speed_r
			If Abs vx < 0.01 Then vx = 0		
		EndIf
		If vy<>0 Then
			y:+vy*speed
			vy:*speed_r
			If Abs vy < 0.01 Then vy = 0
		EndIf
		
		
		If x < 0 Then x = 0; w = 180 - w; vx = -vx+2; TParticle.CreateN Self, 10
		If x > GW Then x = GW; w = 180 - w; vx = -vx-2; TParticle.CreateN Self, 10
		If y < 0 Then y = 0; w = 360 - w; vy = -vy+2; TParticle.CreateN Self, 10
		If y > GH Then y = GH; w = 360 - w; vy = -vy-2; TParticle.CreateN Self, 10

		DrawImage img, x, y, key

		near = findnear()
		i = 0
		If near Then
			For Local b:TBall = EachIn near
				If b.key = key Then
					w = ATan2(y-b.y, x-b.x) + Rand(-10, 10)
				ElseIf Not dead Then
					x:+Cos(ATan2(y-b.y, x-b.x)+180)/4.0*speed
					y:+Sin(ATan2(y-b.y, x-b.x)+180)/4.0*speed
					If ImagesCollide(img, x, y, key, img, b.x, b.y, b.key) Then
						If quakescr = 0 Then
							score:-1000
							TText.Create6 "-1000", x, y, 180, 0, 0	
						EndIf	
						punish 300
						TParticle.CreateN Self, 20
						speed = gspeed/2
					EndIf
					i = 1
				EndIf
			Next
		EndIf		
		If i Then
			SetScale 2, 2
			SetRotation 16*clock
			DrawImage img, x, y, 5
			SetRotation 0
		EndIf
		If islast() Then
			SetScale 1.5, 1.5
			DrawImage img, x, y, 4
		EndIf
		SetScale 1, 1
	EndMethod
	
EndType


Type TParticle Extends TBall
	Global list:TList = New TList
	Field stime:Int, time:Int

	Function CreateN(b:TBall, n)
		Local p:TParticle
		While n
			p = New TParticle
			p.key = b.key
			p.x = b.x + Rand(-20, 20)
			p.y = b.y + Rand(-20, 20)
			list.addlast p
			n:-1
		Wend	
	EndFunction


	Method New()
		w = Rand(0, 359)
		vx = Cos(w)*8
		vy = Sin(w)*8
		stime = MilliSecs()
		time = Rand(100, 400)
	EndMethod

	Method update()
		SetScale 0.4, 0.4
		SetAlpha 1-Float(MilliSecs()-stime)/time	
		x:+vx
		y:+vy
		DrawImage img, x, y, key 
		If MilliSecs() > stime+time Then list.remove Self
	EndMethod
	
	Function updateall()
		For Local p:TParticle = EachIn list
			p.update()
		Next
		SetAlpha 1
		SetScale 1,1
	EndFunction
EndType

Type TText
	Global list:TList = New TList
	Field x:Float, y:Float
	Field vx:Float, vy:Float
	Field stime:Int, time:Int
	Field r, g, b
	Field txt:String, tw, th, lw
		
	Method New()
		stime = MilliSecs()
		time = 1000	
	EndMethod

	Function Create:TText(txt:String, x, y, vx:Float, vy:Float, r, g, b)
		Local t:TText = New TText
		t.txt = txt ; t.x = x ; t.y = y
		t.vx = vx ; t.vy = vy
		t.tw = TextWidth(txt)/2*1.4 ; t.th = TextHeight(txt)/2*1.4
		t.lw = Ceil(Float t.tw/txt.length) + 6
		t.r = r ; t.g = g ; t.b = b
		Return t
	EndFunction
	
	
	Function Create6(txt:String, x, y, r, g, b)
		Local t:TText
		For Local i = 0 To 300 Step 60
			list.addlast Create(txt, x, y, 25*Cos(i), 25*Sin(i), r, g, b)
		Next
		list.addlast Create(txt, x, y, 0, 0, r, g, b)
	EndFunction	
	
	Function updateall()
		For Local t:TText = EachIn list
			t.update()
		Next
		SetAlpha 1
	EndFunction	
	
	Method update()
		Local nx, ny
		SetScale 1.4, 1.4	
		SetAlpha 1-Float(MilliSecs()-stime)/time
		For Local i = 0 Until txt.length
			nx = x-tw+i*lw
			ny = y-th+Sin(16*clock+20*i)*4
			SetColor 0,0,0
			DrawText Chr(txt[i]), nx-1, ny-1	
			SetColor r, g, b
			DrawText Chr(txt[i]), nx, ny
		Next
		SetScale 1, 1
		x:+vx
		y:+vy
		vx:*0.8
		vy:*0.7
		If MilliSecs() > stime+time Then list.remove Self
	EndMethod
EndType